com.h3c.of.ctl.pipeline

## Interface TableContext

-     public interface TableContext

  Encapsulates table properties and associated capabilities.

  The capabilities can be categorized as follows :
  1. capabilities : All the supported basic capabilities.
  2. match capabilities : All the supported capabilities involving matchfield.
  3. match fields : All the supported match fields along with mask.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `containsNextTable(TableId id)` Returns true if the given table is present in next tables set.
    `boolean` | `containsNextTableMiss(TableId id)` Returns true if the given table is present in next tables miss set.
    `TableId` | `getNextTableMiss()` Returns the table Id of the next supported table in the pipeline for a table miss rule.
    `boolean` | `hasNextTablesMiss()` Returns true if the context supports next table in the pipeline for a table miss rule.
    `long` | `maxEntries()` Returns the max entries supported by the table.
    `boolean` | `supportsCapability(TableFeaturePropType prop, OfpCodeBasedEnum code)` Returns true if the context supports given capability-code combination.
    `boolean` | `supportsMatchField(MatchField mf)` Returns true if the context supports given match field.
    `boolean` | `supportsMatchFieldCapability(TableFeaturePropType prop, OxmFieldType code)` Returns true if the context supports given match capability-code combination.
    `boolean` | `supportsWidCards(Set<OxmFieldType> fmmf)` Returns true if the context supports wild carding all of the given match field types.
    `TableId` | `tableId()` Returns the table ID.

- - ### Method Detail

    - #### tableId

          TableId tableId()

      Returns the table ID.
      Returns:
        the table ID

    - #### getNextTableMiss

          TableId getNextTableMiss()

      Returns the table Id of the next supported table in the pipeline for a table miss rule.
      Returns:
        the the next table Id for a table miss rule.

    - #### hasNextTablesMiss

          boolean hasNextTablesMiss()

      Returns true if the context supports next table in the pipeline for a table miss rule.
      Returns:
        true if the context supports next table for table miss rule.

    - #### containsNextTable

          boolean containsNextTable(TableId id)

      Returns true if the given table is present in next tables set.
      Parameters:
        `id` - the table Id
      Returns:
        true if the given Id is present in next table set

    - #### containsNextTableMiss

          boolean containsNextTableMiss(TableId id)

      Returns true if the given table is present in next tables miss set.
      Parameters:
        `id` - the table Id
      Returns:
        true if the given Id is present in next table miss set

    - #### maxEntries

          long maxEntries()

      Returns the max entries supported by the table.
      Returns:
        the max supported entries.

    - #### supportsCapability

          boolean supportsCapability(TableFeaturePropType prop,
                                   OfpCodeBasedEnum code)

      Returns true if the context supports given capability-code combination.
      Parameters:
        `prop` - the given table feature prop type
        `code` - the given capability code
      Returns:
        true if the context supports given capability-code combination.

    - #### supportsMatchFieldCapability

          boolean supportsMatchFieldCapability(TableFeaturePropType prop,
                                             OxmFieldType code)

      Returns true if the context supports given match capability-code combination.
      Parameters:
        `prop` - the given table feature prop type
        `code` - the given capability code
      Returns:
        true if the context supports given match capability-code combination.

    - #### supportsMatchField

          boolean supportsMatchField(MatchField mf)

      Returns true if the context supports given match field. The method also validates the support for masking if the given match field has mask bit set.
      Parameters:
        `mf` - the match field
      Returns:
        true if the context supports given match field

    - #### supportsWidCards

          boolean supportsWidCards(Set<OxmFieldType> fmmf)

      Returns true if the context supports wild carding all of the given match field types.
      Parameters:
        `fmmf` - set of match field types
      Returns:
        true if the context supports wild carding all of the given match field types

Copyright © 2014. All Rights Reserved.